/********************************************
   PROGRAMERSKA RADIONICA
        SKOLA RAJAK
------------------------
PRIMER UPOTREBE SIZEOFOperatora
I DINAMICKE ALOKACIJE PROMENLJIVIH
Autor: Sebastian Novak
Datum: 6.4.2013.
Licenca: Slobodno za upotrebu/modifikaciju
Kontakt: programerska.radionica@gmail.com
               www.rajak.rs
Verzija: 1.0.0
Opis: Primer izracunavanja velicine
svih osnovnih tipova podataka
*******************************************/

#include <stdio.h>
#include <stdlib.h>

int main(){

    int i; // brojac for petlje
    // sizeof proracuni // primeri
    // promenljive za cuvanje velicine svakgo tipa podataka
    int velicinaDouble;
    int velicinaFloat;
    int velicinaChar;
    int velicinaInt;

    int rezultatMain=0;

    // pokazivaci za cuvanje pocetka dinamickih nizova
    // za koje zauzimamo dinamicki memoriju
    double* dinNizDouble;
    float* dinNizFloat;
    char* dinNizChar;
    int*  dinNizInt;

    velicinaDouble = sizeof(double);
    velicinaFloat = sizeof(float);
    velicinaChar = sizeof(char);
    velicinaInt = sizeof(int);

    printf("Double zauzima: %d bajta\n", velicinaDouble);
    printf("Float zauzima: %d bajta\n", velicinaFloat);
    printf("Char zauzima: %d bajta\n", velicinaChar);
    printf("Int zauzima: %d bajta \n", velicinaInt);

    dinNizDouble = malloc(10 * velicinaDouble); // zelim dovoljno bajta za smestanje 10 double
    dinNizFloat = malloc(10 * velicinaFloat);
    dinNizChar = malloc (10 * velicinaChar);
    dinNizInt = malloc(10 * velicinaInt);

    if(dinNizDouble==NULL){
        printf("Neuspesno zauzet niz double-a!");
        rezultatMain=1;
    }
    else if (dinNizFloat==NULL){
        printf("Neuspesno zauzet niz float-a!");
        rezultatMain=1;
    }
    else if (dinNizChar==NULL){
        printf("Neuspesno zauzet niz char!");
        rezultatMain=1;
    }
    else if (dinNizInt==NULL){
        printf("Neuspesno zauzet niz inta!");
        rezultatMain=1;
    }
    // SVE OK
    else{
        printf("\nIspis sadrzaja dinamickog niza double:\n");
        for(i=0;i<10;i++){ // .2lf za ogranicavanje na 2 decimale
            printf("dinNizDouble[%d]=%.2lf\n", i,dinNizDouble[i]);
        }

        printf("\nIspis sadrzaja dinamickog niza float:\n");
        for(i=0;i<10;i++){
            printf("dinNizFloat[%d]=%.2f\n", i , dinNizFloat[i]);
        }

        printf("\nIspis sadrzaja dinamickog niza char:\n");
        for(i=0;i<10;i++){
            printf("dinNizChar[%d]=%c\n", i, dinNizChar[i]);
        }

        printf("\nIspis sadrzaja dinamickog niza int:\n");
        for(i=0;i<10;i++){
            printf("dinNizInt[%d]=%d\n", i, dinNizInt[i]);
        }
        free(dinNizDouble);
        free(dinNizFloat);
        free(dinNizChar);
        free(dinNizInt);
     }
    return rezultatMain;
}
