/********************************************
   PROGRAMERSKA RADIONICA
        SKOLA RAJAK
------------------------
PRIMER IMPLEMENTACIJE
 JEDNOSTRUKO SPREGNUTE LISTE
Autor: Sebastian Novak
Datum: 6.4.2013.
Licenca: Slobodno za upotrebu/modifikaciju
Kontakt: programerska.radionica@gmail.com
               www.rajak.rs
Verzija: 1.0.0
Opis: Dodavanje elemenata u listu
Dodavanje se vrsi uvek na kraju liste
*******************************************/


#include <stdio.h>
#include <stdlib.h>

struct Cvor{
    int informacija;
    struct Cvor* sledeciCvor;
};

int main(){

    struct Cvor* pocetakListe=NULL;
    struct Cvor* tempCvor;
    struct Cvor* noviCvor;
    struct Cvor* CvorZaBrisanje;

    // dodajemo novi element u listu
    if(pocetakListe==NULL){
        //Lista nema nijednog clana, prvi clan se dodaje
        noviCvor = malloc(sizeof(struct Cvor));
        if(noviCvor==NULL){
            printf("NEUSPESNO ZAUZIMANJE MEMORIJE!");
            exit(EXIT_FAILURE);
        }
        noviCvor->informacija = 1337;
        noviCvor->sledeciCvor=NULL; // nema nikog iza njega, on je poslednji
        // POMERAMO POCETAK LISTE NA PRVI ELEMENT, KOJI SMO
        // UPRAVO ZAUZELI DINAMICKI U MEMORIJI
        pocetakListe = noviCvor;
    }
    else{
        // ima jedan ili vise elemenata u listi, moramo da idemo do kraja
        // liste da bi dodali poslednji element
        tempCvor = pocetakListe; // pocetak liste pokazuje na prvi element u listi
        // sada pristupamo prvom elementu liste i idemo da trazimo gde je kraj liste
        // kraj liste je cim nadjemo neki CVOR cije je bolje sledeciCVOR == NULL
        while (tempCvor->sledeciCvor!=NULL){
            tempCvor=tempCvor->sledeciCvor; // predjemo na sledeci cvor
        }
        // izlazimo iz while
        // stigli smo do poslednjeg elementa
        // sada zauzimamo novi cvor
        noviCvor = malloc(sizeof(struct Cvor));
        if(noviCvor==NULL){
            printf("NEUSPESNO ZAUZIMANJE MEMORIJE!");
            exit(EXIT_FAILURE);
        }
        noviCvor->informacija = 1337;
        noviCvor->sledeciCvor=NULL;
    }

    // prolaz kroz celu listu, krece se od pocetka
    tempCvor=pocetakListe;
    while(tempCvor!=NULL){
        printf("Ispis sadrzaja cvora:%d", tempCvor->informacija);
        // prelazak na sledeci cvor
        tempCvor = tempCvor->sledeciCvor;
    }


    // OSLOBADJANJE MEMORIJE KOJU LISTA ZAUZIMA!!!!!
    tempCvor=pocetakListe;
   // redom oslobadjamo svaki deo memorije koji smo zauzeli
   while(tempCvor!=NULL){
        CvorZaBrisanje = tempCvor;
        tempCvor = tempCvor->sledeciCvor;
        free(CvorZaBrisanje);
        printf("\nOslobodjen cvor!");

   }



    return 0;
}
